//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// Matrix Screen Saver 1.0  by Sunshine

// To do:
//   - a bit too slow
//   - Config dialog is missing

// www.sunshine.2kx.de   or    www.welcome.to/sun-shine
// Lloret01@gmx.de

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

program MatrixScr;

uses
  Windows,
  Messages, graphics, sysutils;

{$R *.RES}
{$E SCR}

type
  TSSMode = (ssSetPwd,ssPreview,ssConfig,ssRun);
  
  OneCol = record
    x,y : Integer;   //position of char nearest at the bottom
    long : Integer;
    speed : Integer;
    text : array[1..28] of char;
  end;

const
  max = 100;
  timeout = 50;
  ID_TIMER = 154;

var
  WinClass : TWndClassA;
  Msg : TMsg;
  Handle : Integer;
  winx, winy : Integer;
  can : TCanvas;

  Cols : array[1..max] of OneCol;
  bitmap : TBitmap;

  SSMode      : TSSMode = ssRun;
  Arg1, Arg2  : string;
  CP          :TPoint;

  // Preview
  Prevhwnd    : THandle;
  prevcan     : TCanvas;
  finished : boolean = false;

  mousecount : Integer = 0;
  count : Integer = 0;


// taken from forms.pas; part of Application.ProcessMessages
function ProcessMessage(var Msg: TMsg): Boolean;
var
  Handled: Boolean;
begin
  Result := False;
  if PeekMessage(Msg, 0, 0, 0, PM_REMOVE) then
  begin
    Result := True;
    if Msg.Message <> WM_QUIT then
    begin
      Handled := False;
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
    end;
  end;
end;

procedure SetPassword;
var
 Lib:THandle;
 F: procedure(a:pchar;b:integer;c,d:integer); stdcall;
 Param2,error:integer;
begin
 val(arg2,Param2,error);
 Lib:=LoadLibrary('MPR.DLL');
 if (lib<>32) then begin
  @F:=GetProcAddress(Lib,'PwdChangePasswordA');
  if @F<>nil then F('SCRSAVE',Param2,0,0);
  FreeLibrary(lib);
 end;
end;


function askPassword:boolean;
var Key   : hKey;
    d1,d2 : integer;
    Value : integer;
    Value2 : array[0..1] of char;
    Lib   : THandle;
    F     : function(a:longint):boolean;stdcall;
    LF    : procedure();stdcall;
    WinVer : TOSVERSIONINFO;
begin
 result:=true;
 if (regOpenKeyEx(HKEY_CURRENT_USER,'Control Panel\Desktop',0,Key_Read,Key))=Error_Success then
 begin
  WinVer.dwOSVersionInfoSize:=sizeof(Winver);
  GetVersionEx(Winver);
  if WinVer.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS then
  begin
   D2:=SizeOf(value);
   if (RegQueryValueEx(key,'ScreenSaveUsePassword',nil,@d1,@Value,@D2))=Error_Success then
   begin
     if Value<>0 then
      begin
       Lib:=LoadLibrary('PASSWORD.CPL');
       if Lib<>32 then begin
        @f:=GetProcAddress(lib,'VerifyScreenSavePwd');
        ShowCursor(true);
        if @F<> nil then result:=F(handle);
        ShowCursor(False);
        SetCursorPos(CP.x,CP.y);
        FreeLibrary(lib);
        end;
      end;
    end;
   end;
   if WinVer.dwPlatformId=VER_PLATFORM_WIN32_NT then
   begin
    D2:=SizeOf(value2); d1:=REG_SZ;
    if (RegQueryValueEx(key,'ScreenSaverIsSecure',nil,@d1,@Value2,@D2))=Error_Success then
      if Value2[0]<>'0' then
      begin
        ChangeDisplaySettings(Tdevmode(nil^), 0);
        Lib:=LoadLibrary('user32.dll');
        if Lib<>32 then begin 
         @Lf:=GetProcAddress(lib,'LockWorkStation');
         ShowCursor(true);
         if @LF<> nil then begin finished:=true; LF(); end;
         ShowCursor(False);
         SetCursorPos(CP.x,CP.y);
         FreeLibrary(lib);
        end;
      end;
   end;
   RegCloseKey(Key);
 end;
end;




  
procedure InitCols;
var
  i,j : Integer;
begin
  for i := 1 to max do
  begin
    Cols[i].x := Random(winx div 14) * 14;
    Cols[i].y := -1* (Random(2*winy) + winy);
    Cols[i].long := Random(20) + 8;
    Cols[i].speed := 20;
    for j := 1 to 20 do
    begin
      Cols[i].text[j] := chr(160 + Random(95));
    end;
  end;
end;

Procedure DrawCols;
var
  i,j : Integer;
begin
  for i := 1 to max do
  begin
    for j := 1 to Cols[i].long do
    begin
      if j = 1 then Bitmap.canvas.font.color := $02FFFFFF//RGB(255,255,255)
               else Bitmap.canvas.font.color := RGB(0,255-j*(255 div (Cols[i].long+6)),0);

      Bitmap.Canvas.TextOut(Cols[i].x, Cols[i].y - j*Cols[i].speed, Cols[i].text[j]);
    end;
  end;

end;

Procedure MoveCols;
var
  i,j : Integer;
  tempchar : array[1..20] of char;
begin
  for i := 1 to max do
  begin
    //  Update text
    for j := 1 to Cols[i].long do
      tempchar[j] := Cols[i].text[j];

    for j := 2 to Cols[i].long do
      Cols[i].text[j] := tempchar[j-1];
    Cols[i].text[1] := chr(160 + Random(95));
    // Now move
    Cols[i].y := Cols[i].y + Cols[i].speed;
    If (Cols[i].y - Cols[i].long*abs(bitmap.canvas.Font.height)) > winy
        then Cols[i].y := -1* Random(winy);
  end;
end;





function WindowProc(hWnd, uMsg,wParam,	lParam: Integer): Integer; stdcall;
begin
  Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  case uMsg of
  WM_CREATE : begin
                can := TCanvas.Create;
                can.Handle := GetDc(Hwnd);
                bitmap := TBitmap.Create;
                bitmap.Height := winy; bitmap.Width := winx;
                bitmap.Canvas.brush.color := clblack;
                bitmap.canvas.font.name := 'Courier New';
                bitmap.canvas.font.size := 20;
                bitmap.canvas.font.Color := cllime;
                Randomize;
                InitCols;
                SetTimer(Hwnd,ID_TIMER,timeout,nil);
                ShowCursor(false);
              end;

  WM_DESTROY :begin
                ShowCursor(true);
                KillTimer(hwnd,ID_TIMER);
                can.free;
                bitmap.free;
                halt;
              end;

  WM_MOUSEMOVE : begin
                   inc(mouseCount);
                   if mousecount > 10 then
                     if AskPassword then PostQuitMessage(0) else mousecount := 0;
                 end;
                 
  WM_KEYDOWN: if wParam = VK_ESCAPE then
                 if AskPassword then  SendMessage(hWnd,WM_CLOSE,0,0);

  WM_TIMER : begin
               inc(count);
               MoveCols;
               bitmap.Canvas.brush.color := clblack;
               bitmap.canvas.Rectangle(0,0,winx,winy);

               DrawCols;
               if count < 70 then
               begin
                 bitmap.canvas.font.size := 28;
                 if count > 40 then
                   bitmap.canvas.font.color := RGB(0,255-(count-40)*7,100-(count-40)*3) else
                   bitmap.canvas.font.color := RGB(0,255,100);
                 bitmap.canvas.Font.style := [fsbold];
                 bitmap.canvas.textout(winx div 2 - 130, winy div 2 - 125, 'The Matrix');
                 bitmap.canvas.Font.style := [];
                 bitmap.canvas.font.size := 20;
                 bitmap.canvas.font.Color := cllime;
               end;
               can.Draw(0,0,Bitmap);

             end;
  end;
end;  


begin


// get parameters from command line
  Arg1 := ParamStr(1);
  Arg2 := ParamStr(2);

  if (Copy(Arg1,1,2) = '/a') or (Copy(Arg1,1,2) = '-a') or
     (Copy(Arg1,1,1) = 'a') or (Copy(Arg1,1,2) = '/a') or
     (Copy(Arg1,1,2) = 'a') or (Copy(Arg1,1,2) = '-a') then
     begin
       SSMode := ssSetPwd;
       SetPassword;
     end;

// make sure saver is only started once
  CreateMutex(nil, False, 'myapp');
  if GetLastError = ERROR_ALREADY_EXISTS then Halt(1);
       
  if (Copy(Arg1,1,2) = '/A') or (Copy(Arg1,1,2) = '-A') or
     (Copy(Arg1,1,1) = 'A') then
    SSMode := ssSetPwd;

  if (Copy(Arg1,1,2) = '/P') or (Copy(Arg1,1,2) = '-P') or
     (Copy(Arg1,1,1) = 'P') or (Copy(Arg1,1,2) = '/p') or
     (Copy(Arg1,1,2) = 'p') or (Copy(Arg1,1,2) = '-p') then
    begin
      SSMode := ssPreview;
    end;

  if (Copy(Arg1,1,2) = '/C') or (Copy(Arg1,1,2) = '-C') or
     (Copy(Arg1,1,1) = 'C') or (Copy(Arg1,1,2) = '/c') or
     (Copy(Arg1,1,2) = 'c') or (Copy(Arg1,1,2) = '-c') then
     begin
      SSMode := ssConfig;
      MessageBox(0,pchar('Sunshine' +#39 +'s Matrix Screen Saver 1.0' + #13#13 +
                         'www.sunshine.2kx.de' + #13 + 'Lloret01@gmx.de'
                         ),pchar('MatrixScr'),mb_iconinformation);
     end;


  if (Copy(Arg1,1,2) = '/S') or (Copy(Arg1,1,2) = '-S') or
     (Copy(Arg1,1,1) = 'S') or (Copy(Arg1,1,2) = '/s') or
     (Copy(Arg1,1,2) = '-s') or (Copy(Arg1,1,2) = 's')
     then
     begin
       with WinClass do
       begin
         style              := CS_CLASSDC or CS_PARENTDC;
         lpfnWndProc        := @WindowProc;
         hInstance          := hInstance;
         hbrBackground      := GetStockObject( BLACK_BRUSH );
         lpszClassname      := 'AG_TESTWINDOW';
         hCursor            := LoadCursor(0, IDC_ARROW);
       end;
       RegisterClass(WinClass);
       winx := GetSystemMetrics(SM_CXFULLSCREEN);
       winy := GetSystemMetrics(SM_CXFULLSCREEN);
       Handle :=CreateWindowEx(WS_EX_WINDOWEDGE, 'AG_TESTWINDOW','Sunshines Matrix!',
              WS_VISIBLE or WS_POPUP,0, 0, winx, winy, 0, 0, hInstance, nil);

       UpdateWindow(Handle);
       while(GetMessage(Msg, Handle, 0, 0)) do
       begin
         TranslateMessage(msg);
         DispatchMessage(msg);
       end;
     end;

  IF ssmode = sspreview then
  begin
  PrevHwnd := StrToInt(Arg2);
   while not IsWindowVisible(Prevhwnd) do
     ProcessMessage(MSG);

    prevcan := TCanvas.Create;
    prevcan.Handle := Getdc(PrevHwnd);
    prevcan.brush.Style := bsclear;
    prevcan.font.Style := [fsbold];
    prevcan.font.name := 'Times New Roman';
    prevcan.font.color := cllime;
    prevcan.font.size := 16;

    while IsWindowVisible(PrevhWnd) do
    begin
      prevcan.textout(10,40,'THE MATRIX');
    end;
    prevcan.free;
    halt;

    end;   
end.
